<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.system.mapper.ProcessConfigurationMapper">
    
    <resultMap type="ProcessConfiguration" id="ProcessConfigurationResult">
        <result property="id"    column="id"    />
        <result property="userId"    column="user_id"    />
        <result property="userName"    column="user_name"    />
        <result property="deptId"    column="dept_id"    />
        <result property="deptName"    column="dept_name"    />
        <result property="type"    column="type"    />
        <result property="role"    column="role"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectProcessConfigurationVo">
        select id, user_id, user_name, dept_id, dept_name, type, role, create_by, create_time, update_by, update_time, remark from process_configuration
    </sql>

    <select id="selectProcessConfigurationList" parameterType="ProcessConfiguration" resultMap="ProcessConfigurationResult">
        <include refid="selectProcessConfigurationVo"/>
        <where>
            <if test="userId != null "> and user_id = #{userId}</if>
            <if test="userName != null  and userName != ''"> and user_name like concat('%', #{userName}, '%')</if>
            <if test="deptName != null  and deptName != ''"> and dept_name like concat('%', #{deptName}, '%')</if>
            <if test="type != null  and type != ''"> and type = #{type}</if>
            <if test="role != null  and role != ''"> and role = #{role}</if>
        </where>
    </select>
    
    <select id="selectProcessConfigurationById" parameterType="Long" resultMap="ProcessConfigurationResult">
        <include refid="selectProcessConfigurationVo"/>
        where id = #{id}
    </select>
        
    <insert id="insertProcessConfiguration" parameterType="ProcessConfiguration" useGeneratedKeys="true" keyProperty="id">
        insert into process_configuration
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="userId != null">user_id,</if>
            <if test="userName != null">user_name,</if>
            <if test="deptId != null">dept_id,</if>
            <if test="deptName != null">dept_name,</if>
            <if test="type != null">type,</if>
            <if test="role != null">role,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="userId != null">#{userId},</if>
            <if test="userName != null">#{userName},</if>
            <if test="deptId != null">#{deptId},</if>
            <if test="deptName != null">#{deptName},</if>
            <if test="type != null">#{type},</if>
            <if test="role != null">#{role},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateProcessConfiguration" parameterType="ProcessConfiguration">
        update process_configuration
        <trim prefix="SET" suffixOverrides=",">
            <if test="userId != null">user_id = #{userId},</if>
            <if test="userName != null">user_name = #{userName},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="deptName != null">dept_name = #{deptName},</if>
            <if test="type != null">type = #{type},</if>
            <if test="role != null">role = #{role},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteProcessConfigurationById" parameterType="Long">
        delete from process_configuration where id = #{id}
    </delete>

    <delete id="deleteProcessConfigurationByIds" parameterType="String">
        delete from process_configuration where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>